
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2012 Lanedo GmbH
 */


#include <string.h>

#include "qmi-wda.h"
#include "qmi-enum-types.h"
#include "qmi-enum-types-private.h"
#include "qmi-flags64-types.h"
#include "qmi-error-types.h"
#include "qmi-device.h"
#include "qmi-utils.h"

#define QMI_STATUS_SUCCESS 0x0000
#define QMI_STATUS_FAILURE 0x0001


typedef enum {
    QMI_MESSAGE_WDA_SET_DATA_FORMAT = 0x0020,
    QMI_MESSAGE_WDA_GET_DATA_FORMAT = 0x0021,
} QmiMessageWda;


/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message WDA Set Data Format */


/* --- Input -- */

struct _QmiMessageWdaSetDataFormatInput {
    volatile gint ref_count;

    /* Downlink Data Aggregation Max Size */
    gboolean arg_downlink_data_aggregation_max_size_set;
    guint32 arg_downlink_data_aggregation_max_size;

    /* Downlink Data Aggregation Max Datagrams */
    gboolean arg_downlink_data_aggregation_max_datagrams_set;
    guint32 arg_downlink_data_aggregation_max_datagrams;

    /* NDP Signature */
    gboolean arg_ndp_signature_set;
    guint32 arg_ndp_signature;

    /* Downlink Data Aggregation Protocol */
    gboolean arg_downlink_data_aggregation_protocol_set;
    guint32 arg_downlink_data_aggregation_protocol;

    /* Uplink Data Aggregation Protocol */
    gboolean arg_uplink_data_aggregation_protocol_set;
    guint32 arg_uplink_data_aggregation_protocol;

    /* Link Layer Protocol */
    gboolean arg_link_layer_protocol_set;
    guint32 arg_link_layer_protocol;

    /* QoS Format */
    gboolean arg_qos_format_set;
    guint8 arg_qos_format;
};

#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE 0x16
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS 0x15
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_NDP_SIGNATURE 0x14
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL 0x13
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL 0x12
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_LINK_LAYER_PROTOCOL 0x11
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_QOS_FORMAT 0x10

/**
 * qmi_message_wda_set_data_format_input_get_downlink_data_aggregation_max_size:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @downlink_data_aggregation_max_size: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Max Size' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_get_downlink_data_aggregation_max_size (
    QmiMessageWdaSetDataFormatInput *self,
    guint32 *downlink_data_aggregation_max_size,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_max_size_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Max Size' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_max_size)
        *downlink_data_aggregation_max_size = self->arg_downlink_data_aggregation_max_size;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_set_downlink_data_aggregation_max_size:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @downlink_data_aggregation_max_size: a #guint32.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Downlink Data Aggregation Max Size' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_set_downlink_data_aggregation_max_size (
    QmiMessageWdaSetDataFormatInput *self,
    guint32 downlink_data_aggregation_max_size,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_downlink_data_aggregation_max_size = downlink_data_aggregation_max_size;
    self->arg_downlink_data_aggregation_max_size_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_get_downlink_data_aggregation_max_datagrams:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @downlink_data_aggregation_max_datagrams: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Max Datagrams' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_get_downlink_data_aggregation_max_datagrams (
    QmiMessageWdaSetDataFormatInput *self,
    guint32 *downlink_data_aggregation_max_datagrams,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_max_datagrams_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Max Datagrams' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_max_datagrams)
        *downlink_data_aggregation_max_datagrams = self->arg_downlink_data_aggregation_max_datagrams;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_set_downlink_data_aggregation_max_datagrams:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @downlink_data_aggregation_max_datagrams: a #guint32.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Downlink Data Aggregation Max Datagrams' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_set_downlink_data_aggregation_max_datagrams (
    QmiMessageWdaSetDataFormatInput *self,
    guint32 downlink_data_aggregation_max_datagrams,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_downlink_data_aggregation_max_datagrams = downlink_data_aggregation_max_datagrams;
    self->arg_downlink_data_aggregation_max_datagrams_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_get_ndp_signature:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @ndp_signature: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'NDP Signature' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_get_ndp_signature (
    QmiMessageWdaSetDataFormatInput *self,
    guint32 *ndp_signature,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_ndp_signature_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'NDP Signature' was not found in the message");
        return FALSE;
    }

    if (ndp_signature)
        *ndp_signature = self->arg_ndp_signature;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_set_ndp_signature:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @ndp_signature: a #guint32.
 * @error: Return location for error or %NULL.
 *
 * Set the 'NDP Signature' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_set_ndp_signature (
    QmiMessageWdaSetDataFormatInput *self,
    guint32 ndp_signature,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_ndp_signature = ndp_signature;
    self->arg_ndp_signature_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_get_downlink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @downlink_data_aggregation_protocol: a placeholder for the output #QmiWdaDataAggregationProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_get_downlink_data_aggregation_protocol (
    QmiMessageWdaSetDataFormatInput *self,
    QmiWdaDataAggregationProtocol *downlink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Protocol' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_protocol)
        *downlink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)(self->arg_downlink_data_aggregation_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_set_downlink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @downlink_data_aggregation_protocol: a #QmiWdaDataAggregationProtocol.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Downlink Data Aggregation Protocol' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_set_downlink_data_aggregation_protocol (
    QmiMessageWdaSetDataFormatInput *self,
    QmiWdaDataAggregationProtocol downlink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_downlink_data_aggregation_protocol = (guint32)(downlink_data_aggregation_protocol);
    self->arg_downlink_data_aggregation_protocol_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_get_uplink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @uplink_data_aggregation_protocol: a placeholder for the output #QmiWdaDataAggregationProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Uplink Data Aggregation Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_get_uplink_data_aggregation_protocol (
    QmiMessageWdaSetDataFormatInput *self,
    QmiWdaDataAggregationProtocol *uplink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_uplink_data_aggregation_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Uplink Data Aggregation Protocol' was not found in the message");
        return FALSE;
    }

    if (uplink_data_aggregation_protocol)
        *uplink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)(self->arg_uplink_data_aggregation_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_set_uplink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @uplink_data_aggregation_protocol: a #QmiWdaDataAggregationProtocol.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Uplink Data Aggregation Protocol' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_set_uplink_data_aggregation_protocol (
    QmiMessageWdaSetDataFormatInput *self,
    QmiWdaDataAggregationProtocol uplink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_uplink_data_aggregation_protocol = (guint32)(uplink_data_aggregation_protocol);
    self->arg_uplink_data_aggregation_protocol_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_get_link_layer_protocol:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @link_layer_protocol: a placeholder for the output #QmiWdaLinkLayerProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Link Layer Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_get_link_layer_protocol (
    QmiMessageWdaSetDataFormatInput *self,
    QmiWdaLinkLayerProtocol *link_layer_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_link_layer_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Link Layer Protocol' was not found in the message");
        return FALSE;
    }

    if (link_layer_protocol)
        *link_layer_protocol = (QmiWdaLinkLayerProtocol)(self->arg_link_layer_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_set_link_layer_protocol:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @link_layer_protocol: a #QmiWdaLinkLayerProtocol.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Link Layer Protocol' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_set_link_layer_protocol (
    QmiMessageWdaSetDataFormatInput *self,
    QmiWdaLinkLayerProtocol link_layer_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_link_layer_protocol = (guint32)(link_layer_protocol);
    self->arg_link_layer_protocol_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_get_qos_format:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @qos_format: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'QoS Format' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_get_qos_format (
    QmiMessageWdaSetDataFormatInput *self,
    gboolean *qos_format,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_qos_format_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'QoS Format' was not found in the message");
        return FALSE;
    }

    if (qos_format)
        *qos_format = (gboolean)(self->arg_qos_format);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_input_set_qos_format:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 * @qos_format: a #gboolean.
 * @error: Return location for error or %NULL.
 *
 * Set the 'QoS Format' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_input_set_qos_format (
    QmiMessageWdaSetDataFormatInput *self,
    gboolean qos_format,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_qos_format = (guint8)(qos_format);
    self->arg_qos_format_set = TRUE;

    return TRUE;
}

GType
qmi_message_wda_set_data_format_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageWdaSetDataFormatInput"),
                                          (GBoxedCopyFunc) qmi_message_wda_set_data_format_input_ref,
                                          (GBoxedFreeFunc) qmi_message_wda_set_data_format_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_wda_set_data_format_input_ref:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageWdaSetDataFormatInput *
qmi_message_wda_set_data_format_input_ref (QmiMessageWdaSetDataFormatInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_wda_set_data_format_input_unref:
 * @self: a #QmiMessageWdaSetDataFormatInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_wda_set_data_format_input_unref (QmiMessageWdaSetDataFormatInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageWdaSetDataFormatInput, self);
    }
}

/**
 * qmi_message_wda_set_data_format_input_new:
 *
 * Allocates a new #QmiMessageWdaSetDataFormatInput.
 *
 * Returns: the newly created #QmiMessageWdaSetDataFormatInput. The returned value should be freed with qmi_message_wda_set_data_format_input_unref().
 */
QmiMessageWdaSetDataFormatInput *
qmi_message_wda_set_data_format_input_new (void)
{
    QmiMessageWdaSetDataFormatInput *self;

    self = g_slice_new0 (QmiMessageWdaSetDataFormatInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_wda_set_data_format_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageWdaSetDataFormatInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_WDA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_WDA_SET_DATA_FORMAT);

    /* All TLVs are optional, we allow NULL input */
    if (!input)
        return self;

    /* Try to add the 'Downlink Data Aggregation Max Size' TLV */
    if (input->arg_downlink_data_aggregation_max_size_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint32 variable to the buffer */
        qmi_utils_write_guint32_to_buffer (
            &buffer_aux,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &(input->arg_downlink_data_aggregation_max_size));

        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            g_prefix_error (error, "Couldn't set the Downlink Data Aggregation Max Size TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Downlink Data Aggregation Max Datagrams' TLV */
    if (input->arg_downlink_data_aggregation_max_datagrams_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint32 variable to the buffer */
        qmi_utils_write_guint32_to_buffer (
            &buffer_aux,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &(input->arg_downlink_data_aggregation_max_datagrams));

        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            g_prefix_error (error, "Couldn't set the Downlink Data Aggregation Max Datagrams TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'NDP Signature' TLV */
    if (input->arg_ndp_signature_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint32 variable to the buffer */
        qmi_utils_write_guint32_to_buffer (
            &buffer_aux,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &(input->arg_ndp_signature));

        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_NDP_SIGNATURE,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            g_prefix_error (error, "Couldn't set the NDP Signature TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Downlink Data Aggregation Protocol' TLV */
    if (input->arg_downlink_data_aggregation_protocol_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        {
            guint32 tmp;

            tmp = (guint32)input->arg_downlink_data_aggregation_protocol;
            /* Write the guint32 variable to the buffer */
            qmi_utils_write_guint32_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);
        }

        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            g_prefix_error (error, "Couldn't set the Downlink Data Aggregation Protocol TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Uplink Data Aggregation Protocol' TLV */
    if (input->arg_uplink_data_aggregation_protocol_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        {
            guint32 tmp;

            tmp = (guint32)input->arg_uplink_data_aggregation_protocol;
            /* Write the guint32 variable to the buffer */
            qmi_utils_write_guint32_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);
        }

        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            g_prefix_error (error, "Couldn't set the Uplink Data Aggregation Protocol TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Link Layer Protocol' TLV */
    if (input->arg_link_layer_protocol_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        {
            guint32 tmp;

            tmp = (guint32)input->arg_link_layer_protocol;
            /* Write the guint32 variable to the buffer */
            qmi_utils_write_guint32_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);
        }

        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_LINK_LAYER_PROTOCOL,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            g_prefix_error (error, "Couldn't set the Link Layer Protocol TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'QoS Format' TLV */
    if (input->arg_qos_format_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        {
            guint8 tmp;

            tmp = (guint8)input->arg_qos_format;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_QOS_FORMAT,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            g_prefix_error (error, "Couldn't set the QoS Format TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    return self;
}

/* --- Output -- */

/**
 * QmiMessageResult:
 * @error_status: a #guint16.
 * @error_code: a #guint16.
 *
 * A QmiMessageResult struct.
 */
typedef struct _QmiMessageResult {
    guint16 error_status;
    guint16 error_code;
} QmiMessageResult;

struct _QmiMessageWdaSetDataFormatOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* QoS Format */
    gboolean arg_qos_format_set;
    guint8 arg_qos_format;

    /* Link Layer Protocol */
    gboolean arg_link_layer_protocol_set;
    guint32 arg_link_layer_protocol;

    /* Uplink Data Aggregation Protocol */
    gboolean arg_uplink_data_aggregation_protocol_set;
    guint32 arg_uplink_data_aggregation_protocol;

    /* Downlink Data Aggregation Protocol */
    gboolean arg_downlink_data_aggregation_protocol_set;
    guint32 arg_downlink_data_aggregation_protocol;

    /* NDP Signature */
    gboolean arg_ndp_signature_set;
    guint32 arg_ndp_signature;

    /* Downlink Data Aggregation Max Datagrams */
    gboolean arg_downlink_data_aggregation_max_datagrams_set;
    guint32 arg_downlink_data_aggregation_max_datagrams;

    /* Downlink Data Aggregation Max Size */
    gboolean arg_downlink_data_aggregation_max_size_set;
    guint32 arg_downlink_data_aggregation_max_size;
};

#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT 0x10
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL 0x11
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL 0x12
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL 0x13
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE 0x14
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS 0x15
#define QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE 0x16

/**
 * qmi_message_wda_set_data_format_output_get_result:
 * @self: a QmiMessageWdaSetDataFormatOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_wda_set_data_format_output_get_result (
    QmiMessageWdaSetDataFormatOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_wda_set_data_format_output_get_qos_format:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 * @qos_format: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'QoS Format' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_output_get_qos_format (
    QmiMessageWdaSetDataFormatOutput *self,
    gboolean *qos_format,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_qos_format_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'QoS Format' was not found in the message");
        return FALSE;
    }

    if (qos_format)
        *qos_format = (gboolean)(self->arg_qos_format);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_output_get_link_layer_protocol:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 * @link_layer_protocol: a placeholder for the output #QmiWdaLinkLayerProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Link Layer Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_output_get_link_layer_protocol (
    QmiMessageWdaSetDataFormatOutput *self,
    QmiWdaLinkLayerProtocol *link_layer_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_link_layer_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Link Layer Protocol' was not found in the message");
        return FALSE;
    }

    if (link_layer_protocol)
        *link_layer_protocol = (QmiWdaLinkLayerProtocol)(self->arg_link_layer_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_output_get_uplink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 * @uplink_data_aggregation_protocol: a placeholder for the output #QmiWdaDataAggregationProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Uplink Data Aggregation Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_output_get_uplink_data_aggregation_protocol (
    QmiMessageWdaSetDataFormatOutput *self,
    QmiWdaDataAggregationProtocol *uplink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_uplink_data_aggregation_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Uplink Data Aggregation Protocol' was not found in the message");
        return FALSE;
    }

    if (uplink_data_aggregation_protocol)
        *uplink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)(self->arg_uplink_data_aggregation_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_output_get_downlink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 * @downlink_data_aggregation_protocol: a placeholder for the output #QmiWdaDataAggregationProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_output_get_downlink_data_aggregation_protocol (
    QmiMessageWdaSetDataFormatOutput *self,
    QmiWdaDataAggregationProtocol *downlink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Protocol' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_protocol)
        *downlink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)(self->arg_downlink_data_aggregation_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_output_get_ndp_signature:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 * @ndp_signature: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'NDP Signature' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_output_get_ndp_signature (
    QmiMessageWdaSetDataFormatOutput *self,
    guint32 *ndp_signature,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_ndp_signature_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'NDP Signature' was not found in the message");
        return FALSE;
    }

    if (ndp_signature)
        *ndp_signature = self->arg_ndp_signature;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_output_get_downlink_data_aggregation_max_datagrams:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 * @downlink_data_aggregation_max_datagrams: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Max Datagrams' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_output_get_downlink_data_aggregation_max_datagrams (
    QmiMessageWdaSetDataFormatOutput *self,
    guint32 *downlink_data_aggregation_max_datagrams,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_max_datagrams_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Max Datagrams' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_max_datagrams)
        *downlink_data_aggregation_max_datagrams = self->arg_downlink_data_aggregation_max_datagrams;

    return TRUE;
}

/**
 * qmi_message_wda_set_data_format_output_get_downlink_data_aggregation_max_size:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 * @downlink_data_aggregation_max_size: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Max Size' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_set_data_format_output_get_downlink_data_aggregation_max_size (
    QmiMessageWdaSetDataFormatOutput *self,
    guint32 *downlink_data_aggregation_max_size,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_max_size_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Max Size' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_max_size)
        *downlink_data_aggregation_max_size = self->arg_downlink_data_aggregation_max_size;

    return TRUE;
}

GType
qmi_message_wda_set_data_format_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageWdaSetDataFormatOutput"),
                                          (GBoxedCopyFunc) qmi_message_wda_set_data_format_output_ref,
                                          (GBoxedFreeFunc) qmi_message_wda_set_data_format_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_wda_set_data_format_output_ref:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageWdaSetDataFormatOutput *
qmi_message_wda_set_data_format_output_ref (QmiMessageWdaSetDataFormatOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_wda_set_data_format_output_unref:
 * @self: a #QmiMessageWdaSetDataFormatOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_wda_set_data_format_output_unref (QmiMessageWdaSetDataFormatOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageWdaSetDataFormatOutput, self);
    }
}

static gboolean
qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_size_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Max Size' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Max Size' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_size_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_size_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Size' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_datagrams_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Max Datagrams' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Max Datagrams' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_datagrams_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_datagrams_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Datagrams' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_input_ndp_signature_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'NDP Signature' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'NDP Signature' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_input_ndp_signature_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_NDP_SIGNATURE,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_input_ndp_signature_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'NDP Signature' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_input_downlink_data_aggregation_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_input_downlink_data_aggregation_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_input_downlink_data_aggregation_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_data_aggregation_protocol_get_string ((QmiWdaDataAggregationProtocol)tmp));
#elif defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_data_aggregation_protocol_build_string_from_mask ((QmiWdaDataAggregationProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaDataAggregationProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_input_uplink_data_aggregation_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Uplink Data Aggregation Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Uplink Data Aggregation Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_input_uplink_data_aggregation_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_input_uplink_data_aggregation_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_data_aggregation_protocol_get_string ((QmiWdaDataAggregationProtocol)tmp));
#elif defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_data_aggregation_protocol_build_string_from_mask ((QmiWdaDataAggregationProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaDataAggregationProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Uplink Data Aggregation Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_input_link_layer_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Link Layer Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Link Layer Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_input_link_layer_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_LINK_LAYER_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_input_link_layer_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_LINK_LAYER_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_link_layer_protocol_get_string ((QmiWdaLinkLayerProtocol)tmp));
#elif defined  __QMI_WDA_LINK_LAYER_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_link_layer_protocol_build_string_from_mask ((QmiWdaLinkLayerProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaLinkLayerProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Link Layer Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_input_qos_format_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'QoS Format' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'QoS Format' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_input_qos_format_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_QOS_FORMAT,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_input_qos_format_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'QoS Format' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    static const guint expected_len = 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    return TRUE;
}

static gchar *
qmi_message_result_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (self,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_RESULT,
                                      &buffer_len);
    if (buffer) {
        GString *printable;
        guint16 error_status;
        guint16 error_code;

        printable = g_string_new ("");
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_status);
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_code);

        g_warn_if_fail (buffer_len == 0);

        if (error_status == QMI_STATUS_SUCCESS)
            g_string_append (printable, "SUCCESS");
        else
            g_string_append_printf (printable,
                                    "FAILURE: %s",
                                    qmi_protocol_error_get_string ((QmiProtocolError) error_code));

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_output_qos_format_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'QoS Format' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'QoS Format' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_output_qos_format_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_output_qos_format_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'QoS Format' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_output_link_layer_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Link Layer Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Link Layer Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_output_link_layer_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_output_link_layer_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_LINK_LAYER_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_link_layer_protocol_get_string ((QmiWdaLinkLayerProtocol)tmp));
#elif defined  __QMI_WDA_LINK_LAYER_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_link_layer_protocol_build_string_from_mask ((QmiWdaLinkLayerProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaLinkLayerProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Link Layer Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_output_uplink_data_aggregation_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Uplink Data Aggregation Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Uplink Data Aggregation Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_output_uplink_data_aggregation_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_output_uplink_data_aggregation_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_data_aggregation_protocol_get_string ((QmiWdaDataAggregationProtocol)tmp));
#elif defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_data_aggregation_protocol_build_string_from_mask ((QmiWdaDataAggregationProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaDataAggregationProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Uplink Data Aggregation Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_output_downlink_data_aggregation_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_output_downlink_data_aggregation_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_output_downlink_data_aggregation_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_data_aggregation_protocol_get_string ((QmiWdaDataAggregationProtocol)tmp));
#elif defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_data_aggregation_protocol_build_string_from_mask ((QmiWdaDataAggregationProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaDataAggregationProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_output_ndp_signature_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'NDP Signature' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'NDP Signature' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_output_ndp_signature_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_output_ndp_signature_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'NDP Signature' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_datagrams_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Max Datagrams' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Max Datagrams' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_datagrams_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_datagrams_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Datagrams' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_size_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Max Size' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Max Size' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_size_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE,
                                      &buffer_len);
    if (buffer && qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_size_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Size' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_set_data_format_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_set_data_format_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_set_data_format_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE:
            tlv_type_str = "Downlink Data Aggregation Max Size";
            translated_value = qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_size_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS:
            tlv_type_str = "Downlink Data Aggregation Max Datagrams";
            translated_value = qmi_message_wda_set_data_format_input_downlink_data_aggregation_max_datagrams_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_NDP_SIGNATURE:
            tlv_type_str = "NDP Signature";
            translated_value = qmi_message_wda_set_data_format_input_ndp_signature_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL:
            tlv_type_str = "Downlink Data Aggregation Protocol";
            translated_value = qmi_message_wda_set_data_format_input_downlink_data_aggregation_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL:
            tlv_type_str = "Uplink Data Aggregation Protocol";
            translated_value = qmi_message_wda_set_data_format_input_uplink_data_aggregation_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_LINK_LAYER_PROTOCOL:
            tlv_type_str = "Link Layer Protocol";
            translated_value = qmi_message_wda_set_data_format_input_link_layer_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_INPUT_TLV_QOS_FORMAT:
            tlv_type_str = "QoS Format";
            translated_value = qmi_message_wda_set_data_format_input_qos_format_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT:
            tlv_type_str = "QoS Format";
            translated_value = qmi_message_wda_set_data_format_output_qos_format_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL:
            tlv_type_str = "Link Layer Protocol";
            translated_value = qmi_message_wda_set_data_format_output_link_layer_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL:
            tlv_type_str = "Uplink Data Aggregation Protocol";
            translated_value = qmi_message_wda_set_data_format_output_uplink_data_aggregation_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL:
            tlv_type_str = "Downlink Data Aggregation Protocol";
            translated_value = qmi_message_wda_set_data_format_output_downlink_data_aggregation_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE:
            tlv_type_str = "NDP Signature";
            translated_value = qmi_message_wda_set_data_format_output_ndp_signature_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS:
            tlv_type_str = "Downlink Data Aggregation Max Datagrams";
            translated_value = qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_datagrams_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE:
            tlv_type_str = "Downlink Data Aggregation Max Size";
            translated_value = qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_size_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_set_data_format_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Set Data Format\" (0x0020)\n",
                            line_prefix);

    {
        struct message_set_data_format_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_set_data_format_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageWdaSetDataFormatOutput *
__qmi_message_wda_set_data_format_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageWdaSetDataFormatOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_WDA_SET_DATA_FORMAT, NULL);

    self = g_slice_new0 (QmiMessageWdaSetDataFormatOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_wda_set_data_format_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT,
                                              &buffer_len);
            if (buffer && qmi_message_wda_set_data_format_output_qos_format_validate (buffer, buffer_len)) {
                self->arg_qos_format_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_qos_format = (gboolean)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'QoS Format' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL,
                                              &buffer_len);
            if (buffer && qmi_message_wda_set_data_format_output_link_layer_protocol_validate (buffer, buffer_len)) {
                self->arg_link_layer_protocol_set = TRUE;

                {
                    guint32 tmp;

                    /* Read the guint32 variable from the buffer */
                    qmi_utils_read_guint32_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_link_layer_protocol = (QmiWdaLinkLayerProtocol)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Link Layer Protocol' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL,
                                              &buffer_len);
            if (buffer && qmi_message_wda_set_data_format_output_uplink_data_aggregation_protocol_validate (buffer, buffer_len)) {
                self->arg_uplink_data_aggregation_protocol_set = TRUE;

                {
                    guint32 tmp;

                    /* Read the guint32 variable from the buffer */
                    qmi_utils_read_guint32_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_uplink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Uplink Data Aggregation Protocol' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL,
                                              &buffer_len);
            if (buffer && qmi_message_wda_set_data_format_output_downlink_data_aggregation_protocol_validate (buffer, buffer_len)) {
                self->arg_downlink_data_aggregation_protocol_set = TRUE;

                {
                    guint32 tmp;

                    /* Read the guint32 variable from the buffer */
                    qmi_utils_read_guint32_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_downlink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Protocol' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE,
                                              &buffer_len);
            if (buffer && qmi_message_wda_set_data_format_output_ndp_signature_validate (buffer, buffer_len)) {
                self->arg_ndp_signature_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_ndp_signature));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'NDP Signature' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_DATAGRAMS,
                                              &buffer_len);
            if (buffer && qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_datagrams_validate (buffer, buffer_len)) {
                self->arg_downlink_data_aggregation_max_datagrams_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_downlink_data_aggregation_max_datagrams));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Datagrams' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_SET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE,
                                              &buffer_len);
            if (buffer && qmi_message_wda_set_data_format_output_downlink_data_aggregation_max_size_validate (buffer, buffer_len)) {
                self->arg_downlink_data_aggregation_max_size_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_downlink_data_aggregation_max_size));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Size' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message WDA Get Data Format */


/* --- Input -- */

/* Note: no fields in the Input container */

static QmiMessage *
__qmi_message_wda_get_data_format_request_create (
    guint8 transaction_id,
    guint8 cid,
    gpointer unused,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_WDA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_WDA_GET_DATA_FORMAT);

    return self;
}

/* --- Output -- */

struct _QmiMessageWdaGetDataFormatOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* QoS Format */
    gboolean arg_qos_format_set;
    guint8 arg_qos_format;

    /* Link Layer Protocol */
    gboolean arg_link_layer_protocol_set;
    guint32 arg_link_layer_protocol;

    /* Uplink Data Aggregation Protocol */
    gboolean arg_uplink_data_aggregation_protocol_set;
    guint32 arg_uplink_data_aggregation_protocol;

    /* Downlink Data Aggregation Protocol */
    gboolean arg_downlink_data_aggregation_protocol_set;
    guint32 arg_downlink_data_aggregation_protocol;

    /* NDP Signature */
    gboolean arg_ndp_signature_set;
    guint32 arg_ndp_signature;

    /* Uplink Data Aggregation Max Size */
    gboolean arg_uplink_data_aggregation_max_size_set;
    guint32 arg_uplink_data_aggregation_max_size;

    /* Downlink Data Aggregation Max Size */
    gboolean arg_downlink_data_aggregation_max_size_set;
    guint32 arg_downlink_data_aggregation_max_size;
};

#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT 0x10
#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL 0x11
#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL 0x12
#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL 0x13
#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE 0x14
#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_MAX_SIZE 0x15
#define QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE 0x16

/**
 * qmi_message_wda_get_data_format_output_get_result:
 * @self: a QmiMessageWdaGetDataFormatOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_wda_get_data_format_output_get_result (
    QmiMessageWdaGetDataFormatOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_wda_get_data_format_output_get_qos_format:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 * @qos_format: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'QoS Format' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_get_data_format_output_get_qos_format (
    QmiMessageWdaGetDataFormatOutput *self,
    gboolean *qos_format,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_qos_format_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'QoS Format' was not found in the message");
        return FALSE;
    }

    if (qos_format)
        *qos_format = (gboolean)(self->arg_qos_format);

    return TRUE;
}

/**
 * qmi_message_wda_get_data_format_output_get_link_layer_protocol:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 * @link_layer_protocol: a placeholder for the output #QmiWdaLinkLayerProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Link Layer Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_get_data_format_output_get_link_layer_protocol (
    QmiMessageWdaGetDataFormatOutput *self,
    QmiWdaLinkLayerProtocol *link_layer_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_link_layer_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Link Layer Protocol' was not found in the message");
        return FALSE;
    }

    if (link_layer_protocol)
        *link_layer_protocol = (QmiWdaLinkLayerProtocol)(self->arg_link_layer_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_get_data_format_output_get_uplink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 * @uplink_data_aggregation_protocol: a placeholder for the output #QmiWdaDataAggregationProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Uplink Data Aggregation Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_get_data_format_output_get_uplink_data_aggregation_protocol (
    QmiMessageWdaGetDataFormatOutput *self,
    QmiWdaDataAggregationProtocol *uplink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_uplink_data_aggregation_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Uplink Data Aggregation Protocol' was not found in the message");
        return FALSE;
    }

    if (uplink_data_aggregation_protocol)
        *uplink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)(self->arg_uplink_data_aggregation_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_get_data_format_output_get_downlink_data_aggregation_protocol:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 * @downlink_data_aggregation_protocol: a placeholder for the output #QmiWdaDataAggregationProtocol, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Protocol' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_get_data_format_output_get_downlink_data_aggregation_protocol (
    QmiMessageWdaGetDataFormatOutput *self,
    QmiWdaDataAggregationProtocol *downlink_data_aggregation_protocol,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_protocol_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Protocol' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_protocol)
        *downlink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)(self->arg_downlink_data_aggregation_protocol);

    return TRUE;
}

/**
 * qmi_message_wda_get_data_format_output_get_ndp_signature:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 * @ndp_signature: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'NDP Signature' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_get_data_format_output_get_ndp_signature (
    QmiMessageWdaGetDataFormatOutput *self,
    guint32 *ndp_signature,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_ndp_signature_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'NDP Signature' was not found in the message");
        return FALSE;
    }

    if (ndp_signature)
        *ndp_signature = self->arg_ndp_signature;

    return TRUE;
}

/**
 * qmi_message_wda_get_data_format_output_get_uplink_data_aggregation_max_size:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 * @uplink_data_aggregation_max_size: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Uplink Data Aggregation Max Size' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_get_data_format_output_get_uplink_data_aggregation_max_size (
    QmiMessageWdaGetDataFormatOutput *self,
    guint32 *uplink_data_aggregation_max_size,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_uplink_data_aggregation_max_size_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Uplink Data Aggregation Max Size' was not found in the message");
        return FALSE;
    }

    if (uplink_data_aggregation_max_size)
        *uplink_data_aggregation_max_size = self->arg_uplink_data_aggregation_max_size;

    return TRUE;
}

/**
 * qmi_message_wda_get_data_format_output_get_downlink_data_aggregation_max_size:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 * @downlink_data_aggregation_max_size: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Downlink Data Aggregation Max Size' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_wda_get_data_format_output_get_downlink_data_aggregation_max_size (
    QmiMessageWdaGetDataFormatOutput *self,
    guint32 *downlink_data_aggregation_max_size,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_downlink_data_aggregation_max_size_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Downlink Data Aggregation Max Size' was not found in the message");
        return FALSE;
    }

    if (downlink_data_aggregation_max_size)
        *downlink_data_aggregation_max_size = self->arg_downlink_data_aggregation_max_size;

    return TRUE;
}

GType
qmi_message_wda_get_data_format_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageWdaGetDataFormatOutput"),
                                          (GBoxedCopyFunc) qmi_message_wda_get_data_format_output_ref,
                                          (GBoxedFreeFunc) qmi_message_wda_get_data_format_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_wda_get_data_format_output_ref:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageWdaGetDataFormatOutput *
qmi_message_wda_get_data_format_output_ref (QmiMessageWdaGetDataFormatOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_wda_get_data_format_output_unref:
 * @self: a #QmiMessageWdaGetDataFormatOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_wda_get_data_format_output_unref (QmiMessageWdaGetDataFormatOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageWdaGetDataFormatOutput, self);
    }
}

static gboolean
qmi_message_wda_get_data_format_output_qos_format_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'QoS Format' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'QoS Format' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_get_data_format_output_qos_format_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT,
                                      &buffer_len);
    if (buffer && qmi_message_wda_get_data_format_output_qos_format_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'QoS Format' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_get_data_format_output_link_layer_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Link Layer Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Link Layer Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_get_data_format_output_link_layer_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_get_data_format_output_link_layer_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_LINK_LAYER_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_link_layer_protocol_get_string ((QmiWdaLinkLayerProtocol)tmp));
#elif defined  __QMI_WDA_LINK_LAYER_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_link_layer_protocol_build_string_from_mask ((QmiWdaLinkLayerProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaLinkLayerProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Link Layer Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_get_data_format_output_uplink_data_aggregation_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Uplink Data Aggregation Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Uplink Data Aggregation Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_get_data_format_output_uplink_data_aggregation_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_get_data_format_output_uplink_data_aggregation_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_data_aggregation_protocol_get_string ((QmiWdaDataAggregationProtocol)tmp));
#elif defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_data_aggregation_protocol_build_string_from_mask ((QmiWdaDataAggregationProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaDataAggregationProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Uplink Data Aggregation Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_get_data_format_output_downlink_data_aggregation_protocol_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Protocol' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Protocol' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_get_data_format_output_downlink_data_aggregation_protocol_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL,
                                      &buffer_len);
    if (buffer && qmi_message_wda_get_data_format_output_downlink_data_aggregation_protocol_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_wda_data_aggregation_protocol_get_string ((QmiWdaDataAggregationProtocol)tmp));
#elif defined  __QMI_WDA_DATA_AGGREGATION_PROTOCOL_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_wda_data_aggregation_protocol_build_string_from_mask ((QmiWdaDataAggregationProtocol)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiWdaDataAggregationProtocol
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Protocol' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_get_data_format_output_ndp_signature_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'NDP Signature' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'NDP Signature' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_get_data_format_output_ndp_signature_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE,
                                      &buffer_len);
    if (buffer && qmi_message_wda_get_data_format_output_ndp_signature_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'NDP Signature' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_get_data_format_output_uplink_data_aggregation_max_size_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Uplink Data Aggregation Max Size' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Uplink Data Aggregation Max Size' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_get_data_format_output_uplink_data_aggregation_max_size_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_MAX_SIZE,
                                      &buffer_len);
    if (buffer && qmi_message_wda_get_data_format_output_uplink_data_aggregation_max_size_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Uplink Data Aggregation Max Size' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_wda_get_data_format_output_downlink_data_aggregation_max_size_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Downlink Data Aggregation Max Size' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Downlink Data Aggregation Max Size' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_wda_get_data_format_output_downlink_data_aggregation_max_size_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE,
                                      &buffer_len);
    if (buffer && qmi_message_wda_get_data_format_output_downlink_data_aggregation_max_size_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Size' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_get_data_format_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_get_data_format_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_get_data_format_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT:
            tlv_type_str = "QoS Format";
            translated_value = qmi_message_wda_get_data_format_output_qos_format_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL:
            tlv_type_str = "Link Layer Protocol";
            translated_value = qmi_message_wda_get_data_format_output_link_layer_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL:
            tlv_type_str = "Uplink Data Aggregation Protocol";
            translated_value = qmi_message_wda_get_data_format_output_uplink_data_aggregation_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL:
            tlv_type_str = "Downlink Data Aggregation Protocol";
            translated_value = qmi_message_wda_get_data_format_output_downlink_data_aggregation_protocol_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE:
            tlv_type_str = "NDP Signature";
            translated_value = qmi_message_wda_get_data_format_output_ndp_signature_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_MAX_SIZE:
            tlv_type_str = "Uplink Data Aggregation Max Size";
            translated_value = qmi_message_wda_get_data_format_output_uplink_data_aggregation_max_size_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE:
            tlv_type_str = "Downlink Data Aggregation Max Size";
            translated_value = qmi_message_wda_get_data_format_output_downlink_data_aggregation_max_size_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_get_data_format_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Get Data Format\" (0x0021)\n",
                            line_prefix);

    {
        struct message_get_data_format_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_get_data_format_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageWdaGetDataFormatOutput *
__qmi_message_wda_get_data_format_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageWdaGetDataFormatOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_WDA_GET_DATA_FORMAT, NULL);

    self = g_slice_new0 (QmiMessageWdaGetDataFormatOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_wda_get_data_format_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_QOS_FORMAT,
                                              &buffer_len);
            if (buffer && qmi_message_wda_get_data_format_output_qos_format_validate (buffer, buffer_len)) {
                self->arg_qos_format_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_qos_format = (gboolean)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'QoS Format' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_LINK_LAYER_PROTOCOL,
                                              &buffer_len);
            if (buffer && qmi_message_wda_get_data_format_output_link_layer_protocol_validate (buffer, buffer_len)) {
                self->arg_link_layer_protocol_set = TRUE;

                {
                    guint32 tmp;

                    /* Read the guint32 variable from the buffer */
                    qmi_utils_read_guint32_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_link_layer_protocol = (QmiWdaLinkLayerProtocol)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Link Layer Protocol' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_PROTOCOL,
                                              &buffer_len);
            if (buffer && qmi_message_wda_get_data_format_output_uplink_data_aggregation_protocol_validate (buffer, buffer_len)) {
                self->arg_uplink_data_aggregation_protocol_set = TRUE;

                {
                    guint32 tmp;

                    /* Read the guint32 variable from the buffer */
                    qmi_utils_read_guint32_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_uplink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Uplink Data Aggregation Protocol' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_PROTOCOL,
                                              &buffer_len);
            if (buffer && qmi_message_wda_get_data_format_output_downlink_data_aggregation_protocol_validate (buffer, buffer_len)) {
                self->arg_downlink_data_aggregation_protocol_set = TRUE;

                {
                    guint32 tmp;

                    /* Read the guint32 variable from the buffer */
                    qmi_utils_read_guint32_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_downlink_data_aggregation_protocol = (QmiWdaDataAggregationProtocol)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Protocol' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_NDP_SIGNATURE,
                                              &buffer_len);
            if (buffer && qmi_message_wda_get_data_format_output_ndp_signature_validate (buffer, buffer_len)) {
                self->arg_ndp_signature_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_ndp_signature));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'NDP Signature' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_UPLINK_DATA_AGGREGATION_MAX_SIZE,
                                              &buffer_len);
            if (buffer && qmi_message_wda_get_data_format_output_uplink_data_aggregation_max_size_validate (buffer, buffer_len)) {
                self->arg_uplink_data_aggregation_max_size_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_uplink_data_aggregation_max_size));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Uplink Data Aggregation Max Size' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_WDA_GET_DATA_FORMAT_OUTPUT_TLV_DOWNLINK_DATA_AGGREGATION_MAX_SIZE,
                                              &buffer_len);
            if (buffer && qmi_message_wda_get_data_format_output_downlink_data_aggregation_max_size_validate (buffer, buffer_len)) {
                self->arg_downlink_data_aggregation_max_size_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_downlink_data_aggregation_max_size));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Downlink Data Aggregation Max Size' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* Service-specific printable: WDA */


gchar *
__qmi_message_wda_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    if (qmi_message_is_indication (self)) {
        switch (qmi_message_get_message_id (self)) {
         default:
             return NULL;
        }
    } else {
        switch (qmi_message_get_message_id (self)) {
        case QMI_MESSAGE_WDA_SET_DATA_FORMAT:
            return message_set_data_format_get_printable (self, line_prefix);
        case QMI_MESSAGE_WDA_GET_DATA_FORMAT:
            return message_get_data_format_get_printable (self, line_prefix);
         default:
             return NULL;
        }
    }
}

gboolean
__qmi_message_wda_get_version_introduced (
    QmiMessage *self,
    guint *major,
    guint *minor)
{
    switch (qmi_message_get_message_id (self)) {
    case QMI_MESSAGE_WDA_SET_DATA_FORMAT:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_WDA_GET_DATA_FORMAT:
        *major = 1;
        *minor = 0;
        return TRUE;
    default:
        return FALSE;
    }
}

/*****************************************************************************/
/* CLIENT: QMI Client WDA */


/**
 * SECTION: qmi-client-wda
 * @title: QmiClientWda
 * @short_description: #QmiClient for the WDA service.
 *
 * #QmiClient which handles operations in the WDA service.
 */

G_DEFINE_TYPE (QmiClientWda, qmi_client_wda, QMI_TYPE_CLIENT);

static void
process_indication (QmiClient *self,
                    QmiMessage *message)
{
    switch (qmi_message_get_message_id (message)) {
        default:
            break;
    }
}

static void
qmi_client_wda_init (QmiClientWda *self)
{
}

static void
qmi_client_wda_class_init (QmiClientWdaClass *klass)
{
    QmiClientClass *client_class = QMI_CLIENT_CLASS (klass);

    client_class->process_indication = process_indication;
}


/**
 * qmi_client_wda_set_data_format_finish:
 * @self: a #QmiClientWda.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_wda_set_data_format().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_wda_set_data_format().
 *
 * Returns: a #QmiMessageWdaSetDataFormatOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_wda_set_data_format_output_unref().
 */
QmiMessageWdaSetDataFormatOutput *
qmi_client_wda_set_data_format_finish (
    QmiClientWda *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_wda_set_data_format_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
set_data_format_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageWdaSetDataFormatOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_wda_set_data_format_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_wda_set_data_format_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_wda_set_data_format:
 * @self: a #QmiClientWda.
 * @input: a #QmiMessageWdaSetDataFormatInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Set Data Format request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_wda_set_data_format_finish() to get the result of the operation.
 */
void
qmi_client_wda_set_data_format (
    QmiClientWda *self,
    QmiMessageWdaSetDataFormatInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_wda_set_data_format);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_wda_set_data_format_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)set_data_format_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_wda_get_data_format_finish:
 * @self: a #QmiClientWda.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_wda_get_data_format().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_wda_get_data_format().
 *
 * Returns: a #QmiMessageWdaGetDataFormatOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_wda_get_data_format_output_unref().
 */
QmiMessageWdaGetDataFormatOutput *
qmi_client_wda_get_data_format_finish (
    QmiClientWda *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_wda_get_data_format_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
get_data_format_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageWdaGetDataFormatOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_wda_get_data_format_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_wda_get_data_format_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_wda_get_data_format:
 * @self: a #QmiClientWda.
 * @unused: %NULL. This message doesn't have any input bundle.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Get Data Format request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_wda_get_data_format_finish() to get the result of the operation.
 */
void
qmi_client_wda_get_data_format (
    QmiClientWda *self,
    gpointer unused,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_wda_get_data_format);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_wda_get_data_format_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  NULL,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)get_data_format_ready,
                        result);
    qmi_message_unref (request);
}

